<!-- toc -->

- [About This Project](#About-This-Project)
- [Getting Started](#Getting-Started)
  * [Prerequisites](#Prerequisites)
- [Usage](#Usage)
  * [Columns mapping](#Columns-mapping)
- [License](#License)
- [Feedback](#Feedback)

<!-- tocstop -->
<!-- ABOUT THIS PROJECT -->
## About This Project
Client-examples is a command-line java implementation for Analytic Reporting Services. It is certainly not perfect, but it is a practical demostration that can provide a better understanding for developers.

## Getting Started


### Prerequisites
This application is build with 
* [Java](https://www.java.com/) - Above 8u161 (1.8.0_161)
* [Maven](https://maven.apache.org/) - Dependency Management

If you need to build your own .jar file, a familiarization with the requirement is recommand.


## Usage


    Note: the location of first two arguments are fixed.
    
    Fixed arguments:
        ReportTypes:                    Available from RTS28, RTS27, FITCA
        Actions:                        Available from RUN, QUERY, GET
   
    Required arguments:
        -u | --username                 AAA user name
        -p | --password                 AAA password
    
    Optional arguments:
        -j | --job                      The job ID
        -h | --help                     Show help message and exit
        -d | --data                     Local data directory path which contain files of client raw data
        -k | --key                      The key used to encrypt data
        -s | --start                    Start date, default <previousYear>-01-01
        -e | --end                      End date, default <previousYear>-12-31
        -f | --firm                     Firm entity id, default ALL firms
        -c | --class                    PermId of CoFI, default ALL CoFIs
        -m | --email                    The email address for notification. Default to use the username
        -r | --report                   Local directory path to store reports downloaded
    
    Examples:
    
      RUN
    java -jar mifid-reporting-client.jar RTS28 RUN -u \"username\" -p \"password\" -d \"dataPath\" -k \"encryptKey\" -s \"2018-01-01\" -e \"2018-12-31\" -f \"firmEntity\" -c \"CoFI\"

      QUERY
    java -jar mifid-reporting-client.jar RTS28 QUERY -u \"username\" -p \"password\" -j \"jobId\"

      GET
    java -jar mifid-reporting-client.jar RTS28 GET -u \"username\" -p \"password\" -j \"jobId\" -r \"reportPath\" -k \"encryptKey\"

Detailed usage of optional arguments for different Actions and ReportTypes please refer to below table.

**R** for required, **O** for optional.
* RUN


|ReportType|data|key|start|end|firm|class|email|
|-|:-:|:-:|:-:|:-:|:-:|:-:|:-:|:-:|
|RTS28|R|R|R|R|R|R|O|
|RTS27|R|R|R|R| | |O|
|FITCA|R|R| | | | |O|

* QUERY


|ReportType|job|
|-|:-:|
|ALL|R|

* GET


|ReportType|job|key|report|
|-|:-:|:-:|:-:|
|ALL|R|R|R|

### Columns mapping

If your CSV file has different columns than our example input file, you can use ColumnsMapping file to map each column of your CSV file to our defined column names. Both example input file and ColumnsMapping file are availabe under the path *java/MiFID_Reporting/sampleData*

You need to modify ColumnsMapping file and put it into input folders in order to take effect. How to edit ColumnsMaspping file is written inside.

## License

Copyright (c) 2019 by Refinitiv. All rights reserved.
No portion of this software in any form may be used or
reproduced in any manner without written consent from
Refinitiv.

<!-- FEEDBACK -->
## Feedback

We invite your comments, corrections, and suggestions about this document: access the [Feedback](https://my.refinitiv.com/content/mytr/en/helpandsupport.html) option under [Help & Support](https://my.refinitiv.com/content/mytr/en/helpandsupport.html) at [MyRefinitiv](https://my.refinitiv.com/content/mytr/en/signin.html). Your feedback helps us continue to improve our user assistance.