/*
 *  Copyright (c) 2019 by Refinitiv. All rights reserved.
 *
 *  No portion of this software in any form may be used or
 *  reproduced in any manner without written consent from
 *  Refinitiv
 */
package com.refinitiv.analytics.reportingservice.config;

import org.aeonbits.owner.Config;

@SysConfig.LoadPolicy(SysConfig.LoadType.MERGE)
@SysConfig.Sources({"file:mifid.reporting.properties",
    "file:config/mifid.reporting.properties",
    "classpath:config/mifid.reporting.properties"})
public interface SysConfig extends Config {

  @Key("refinitiv.edpapi.url")
  @DefaultValue("https://us-east-1-staging-api.refinitiv.com")
  String getEdpApiUrl();

  @Key("refinitiv.edpapi.timeOut")
  @DefaultValue("60")
  int getEdpApiTimeOut();

  @Key("endpoint.auth.token")
  @DefaultValue("/auth/oauth2/v1/token")
  String getEndpointOfAuthToken();

  @Key("endpoint.auth.credentials")
  @DefaultValue("/auth/cloud_credentials/v1")
  String getEndpointOfAuthCredentials();

  @Key("endpoint.analytics.reporting")
  @DefaultValue("/reporting-services/beta1")
  String getEndpointOfAnaltyicsReporting();

  @Key("proxy.ip")
  @DefaultValue("")
  String getNetworkProxyIp();

  @Key("proxy.port")
  @DefaultValue("-1")
  int getNetworkProxyPort();
}
